import { Component, ElementRef, Input, OnInit, ViewChild, ViewEncapsulation } from '@angular/core';

@Component({
    selector: 'collab-comp-img-generator',
    templateUrl: './img-generator.component.html',
    styleUrls: ['./img-generator.component.scss'],
    encapsulation: ViewEncapsulation.None
})
export class ImgGeneratorComponent implements OnInit {
    @Input() public imgUrl: string | undefined = '';
    @Input() public altText: string | undefined = '';
    @Input() public fontClassName: string = '';
    @Input() public fontSize: 'icon--sm' | 'icon--md' | 'icon--lg' | 'icon--xl' | 'icon--xxl' | 'icon--xxxl' = 'icon--md';

    @ViewChild('loadSvgImage', {
        static: false
    }) public loadSvgImage!: ElementRef < HTMLInputElement > ;

    constructor() {}

    public ngOnInit(): void {
        this.altText = this.altText ? this.altText : '';
    }

    get fontClassNames(){
        return `${this.fontClassName} ${ this.fontSize }`;
    }
}
