import { Component, OnInit } from "@angular/core";
import { POLICY_TOKEN_KEY } from "../core/constants";
import { CookieService } from "../core/services/cookie.service";
import { SessionStorageService } from "../core/services/session-storage.service";

@Component({
  selector: "app-policy-banner",
  templateUrl: "./policy-banner.component.html",
  styleUrls: ["./policy-banner.component.scss"],
})
export class PolicyBannerComponent implements OnInit {
  constructor(
    public cookieService: CookieService,
    public sessionStorageService: SessionStorageService
  ) {}

  ngOnInit(): void {
    if (!!this.sessionStorageService.getLocalStorage(POLICY_TOKEN_KEY)) {
      this.cookieService.showCookiePolicy =
        this.sessionStorageService.getLocalStorage(POLICY_TOKEN_KEY) === "pending"
          ? true
          : false;
    } else {
      this.sessionStorageService.setLocalStorage(POLICY_TOKEN_KEY, "pending");
      this.cookieService.showCookiePolicy = true;
    }
  }

  onClick(): void {
    this.sessionStorageService.deleteLocalStorage(POLICY_TOKEN_KEY);
    this.sessionStorageService.setLocalStorage(POLICY_TOKEN_KEY, "accepted");
    this.cookieService.showCookiePolicy = false;
  }

  goToPolicy(): void {
    window.open("https://en.wikipedia.org/wiki/Privacy_policy", "_blank");
  }
}
