import { Component, Input } from '@angular/core';


@Component({
    selector: 'collab-comp-progress-bar-horizontal',
    template: `
  <div class="bar-wrapper {{backgoundClass}}">
      <div class="bar-progress {{progressClass}}" [ngStyle]="{'width': barWidth}">
      </div>
  </div>
  `,
    styles: [
        `
            .bar-wrapper{
              width: 100%;
              background: #E5E5E5;
              margin: auto;
            }
            .bar-progress{
              background: #007400;
              height: 5px;
            }
    `,
    ],
})
export class ProgressBarHorizontalComponent {
    @Input() progress: number = 0;
    @Input() backgoundClass!: string;
    @Input() progressClass!: string;

    get barWidth() {
        return this.progress + '%';
    }
}
