import {Injectable} from '@angular/core';
import {HttpClient, HttpHeaders} from '@angular/common/http';
import {Observable} from 'rxjs';
import {SessionStorageService} from '../core/services/session-storage.service';
import {CookieService} from '../core/services/cookie.service';
import {REFRESH_TOKEN_KEY} from '../core/constants';
import { UtilityService } from '../core/services/utility.service';

@Injectable()
export class TimeoutService {
    constructor(private http: HttpClient, private sessionStorageService: SessionStorageService, private cookieService: CookieService, private utilityService: UtilityService) {
    }
    refreshToken(): Observable<any> {
        const url = this.utilityService.getEnvironmentVariable() + '/user/refresh'; // TODO: replace url

        // const url = 'http://dev-api.avateam.io/user/refresh'; // TODO: replace url

        // console.log(this.utilityService.getEnvironmentVariable());
        const payload = {userId: this.sessionStorageService.getStorage('userId')};
        const httpOptions = {
            headers: new HttpHeaders({
                [REFRESH_TOKEN_KEY]: this.cookieService.getCookie(REFRESH_TOKEN_KEY)
            }),
            observe: 'response' as 'body'
        };

        return this.http.post(url, payload, httpOptions);
    }
}
